#pragma comment(exestr, "@(#) acfg.c 6.1 94/09/23 SCOINC")

/*
 *      Copyright (C) The Santa Cruz Operation, 1994
 *      This Module contains Proprietary Information of
 *      The Santa Cruz Operation and should be treated as
 *      Confidential.
 */

#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include "pntsetup.h"
#include <sys/tss.h>
#include <sys/immu.h>
#include <sys/region.h>
#include <sys/param.h>
#include <sys/proc.h>
#include <sys/sysi86.h>
#include <sys/v86.h>
#include <sys/errno.h>

char dir[128];

/*
 * usage():     Display usage message and exit.
 */
usage(prog)
char *prog;
{
        fprintf(stderr, "\nUsage: %s -d <directory>\n", prog);
        exit (0);
}

/*
 * get_args():  Parse command line argumants.
 */
get_args(argc, argv)
char **argv;
{
        if (argc != 3) {
                usage(argv[0]);
        }

        if (strcmp(argv[1], "-d") != 0) {
                usage(argv[0]);
        }
        strcpy(dir, argv[2]);
        return 0;
}

main(argc, argv)
char **argv;
{
        if (geteuid() != 0) {
                fprintf(stderr, "You must be superuser to run this program!\n");
                exit(1);
        }

        /* Call the routine that enables I/O operation */
        if (sysi86(SI86V86, V86SC_IOPL, 0x3000) < 0) {
                perror("Cannot enable direct I/O!");
                exit(1);
        }

        get_args(argc, argv);
        brdsrch();
        exit(0);
}
