#pragma comment(exestr, "@(#) boardio.c 7.1 94/11/30 SCOINC")

/*
 *      Copyright (C) The Santa Cruz Operation, 1994.
 *      This Module contains Proprietary Information of
 *      The Santa Cruz Operation and should be treated
 *      as Confidential.
 */

#include <stdio.h>
#include "pntsetup.h"
#include <sys/types.h>
#include <sys/timeb.h>
#include <sys/immu.h>
#include <sys/signal.h>

/*
 * brdsrch(): search for PCnet boards.
 *
 * Returns: number of PCnet boards found.
 */
void
brdsrch()
{
        register int                    i = 0, j;
        char                                    path[128];
        int                                     boardnum;
        extern char                             dir[];
        FILE                                    *fp;
        unsigned long                           port = 0x200;
        unsigned long                           iobase = 0, irq = 0;
        long                            dma = -1;
        long chip_type, checksum = 0;

     for (boardnum = 0; boardnum < 4 ; boardnum ++) 
     {
           iobase = port;
           if(port < 0x400) 
              port += 0x20;    /* go for the next possible location */
           else
              break;       /* no more possible locations to search */


           if ((unsigned char)inb (iobase+14) != 'W') 
           {
               boardnum --;
               continue;
           }

           if ((unsigned char)inb (iobase+15) != 'W') 
           {
               boardnum --;
               continue;
           }

           for ( i = 0; i < 12; i++)
           checksum += (inb (iobase + i) & 0xff);

           chip_type = inb(iobase + 0x9) & 0xff; 

           checksum += (inb (iobase + 14) & 0xff);
           checksum += (inb (iobase + 15) & 0xff);

           if (checksum != (((inb(iobase+13) & 0xff) << 8) | (inb(iobase+12) & 0xff)))
           {
               boardnum --;
               continue;
           }
           /* printf("checksum = %x\n",checksum);
           printf("12 = %x\n",inb(iobase+12));
           printf("13 = %x\n",inb(iobase+13)); */
              /* This is PCNet device! */

           sprintf(path, "%s/%d", dir, boardnum);
           if ((fp = fopen(path, "w")) == (FILE *)0 ) 
           {
             perror("pnt-acfg: Unable to create AOF output stanza file");
             exit(1);
           }

           fprintf(fp, "BASE_IO:\n");      /* Stanza Section */
           fprintf(fp, "\tSELECT=%x\n", iobase);
           fprintf(fp, "ADAPTER:\n");
           fprintf(fp, "\tAOF=pnt\n");
  /* Is it jumperless card, ISA+ or ISA-2 or PCNet-32 ? */
           if((chip_type == 0x1)||(chip_type == 0x10))
           fprintf(fp, "\tREQUIRED=\n");

            fflush(fp);
            fclose(fp);
            iobase = 0;  /* ready to search for the next AMD device */
     }
}
